## therion 6.0.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
include(cmake/PreventInSourceBuilds.cmake)

project(therion)
set(CMAKE_CXX_STANDARD 14)
# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")

option(BUILD_THERION "Build therion executable." ON)
option(BUILD_LOCH "Build loch executable." ON)
option(BUILD_THBOOK "Build thbook.pdf." ON)
option(BUILD_XTHERION "Build xtherion." ON)

include(GNUInstallDirs)
include(cmake/BuildType.cmake)
include(cmake/Dependencies.cmake)
include(cmake/TherionSources.cmake)
include(cmake/ECMEnableSanitizers.cmake)

# strip binaries in release build
set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -s")

set(ECM_ENABLE_SANITIZERS "" CACHE STRING 
    "Enable runtime sanitizers, available options: address,memory,thread,leak,undefined." )
set(ENABLE_THDEBUG OFF CACHE BOOL "Print debug information.")

option(ENABLE_CLANG_TIDY "Enable static analysis with clang-tidy." OFF)
if (ENABLE_CLANG_TIDY)
    find_program(CLANG_TIDY_EXECUTABLE clang-tidy)
    if (CLANG_TIDY_EXECUTABLE)
        set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXECUTABLE};--quiet")
    endif()
endif()

option(ENABLE_CCACHE "Enable compiler cache." OFF)
if (ENABLE_CCACHE)
    find_program(CCACHE_EXECUTABLE ccache)
    mark_as_advanced(CCACHE_EXECUTABLE)
    if(CCACHE_EXECUTABLE)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_EXECUTABLE})
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE_EXECUTABLE})
    endif()
endif()

# determine platform
if(UNIX AND NOT APPLE)
    set(THPLATFORM LINUX)
elseif(APPLE)
    set(THPLATFORM MACOSX)
else()
    set(THPLATFORM WIN32)
endif()

# tell CMake which files must be generated now, doing so in subfolders is too late
set_source_files_properties(
    ${CMAKE_BINARY_DIR}/thchencdata.h
    ${CMAKE_BINARY_DIR}/thchencdata.cxx
    ${CMAKE_BINARY_DIR}/thlangdata.h
    ${CMAKE_BINARY_DIR}/thlangdatafields.h
    ${CMAKE_BINARY_DIR}/thmpost.h 
    ${CMAKE_BINARY_DIR}/thmpost.cxx
    ${CMAKE_BINARY_DIR}/thsymbolsets.h
    ${CMAKE_BINARY_DIR}/thsymbolsets.cxx
    ${CMAKE_BINARY_DIR}/thversion.h
    ${CMAKE_BINARY_DIR}/thcsdata.h
    ${CMAKE_BINARY_DIR}/thcsdata.cxx
    ${CMAKE_BINARY_DIR}/thsymbolsetlist.h
    ${CMAKE_BINARY_DIR}/thtex.h
    ${CMAKE_BINARY_DIR}/thtex.cxx
    PROPERTIES GENERATED TRUE 
)

# copy given files to the build dir
function(therion_copy_files)
    foreach(FILE_NAME ${ARGV})
        configure_file(${FILE_NAME} ${FILE_NAME} COPYONLY)
    endforeach()
endfunction()

# make lists of names with source and binary dir prefixes
macro(therion_make_files_lists LIST_NAME)
    foreach(FILE_NAME ${ARGN})
        list(APPEND ${LIST_NAME}_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${FILE_NAME})
        list(APPEND ${LIST_NAME}_BIN ${CMAKE_CURRENT_BINARY_DIR}/${FILE_NAME})
    endforeach()
endmacro()

# copy files needed by some build steps
therion_copy_files(thcsdata.tcl thsymbolsetfont.txt .clang-tidy)

# generate thcsdata sources
add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/thcsdata.h
                          ${CMAKE_BINARY_DIR}/thcsdata.cxx
                   COMMAND tclsh thcsdata.tcl ${PROJ_PREFIX}/share/proj
                   DEPENDS ${CMAKE_BINARY_DIR}/thcsdata.tcl
                   WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)
add_custom_target(generate_thcsdata DEPENDS
    ${CMAKE_BINARY_DIR}/thcsdata.h
    ${CMAKE_BINARY_DIR}/thcsdata.cxx
)

# generate thsymbolsetlist sources
add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/thsymbolsetlist.h
    COMMAND perl
    ARGS ${CMAKE_SOURCE_DIR}/thsymbolsetlist.pl
    DEPENDS ${CMAKE_SOURCE_DIR}/thsymbolsetlist.pl 
            ${CMAKE_BINARY_DIR}/mpost/thTrans.mp
            ${CMAKE_BINARY_DIR}/thsymbolsetfont.txt
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)
add_custom_target(generate_thsymbolsetlist DEPENDS ${CMAKE_BINARY_DIR}/thsymbolsetlist.h)

# check if there are artifacts from the legacy Makefile in the source dir,
# which could interfere with the CMake build
add_custom_target(legacy-make 
    ${CMAKE_COMMAND} -P cmake/DetectLegacyBuild.cmake
    COMMENT "Checking for legacy build"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

# generate version files
add_custom_target(version python3 set_version.py ${CMAKE_BINARY_DIR}
                  COMMENT "Updating version"
                  BYPRODUCTS ${CMAKE_BINARY_DIR}/thversion.h
                             ${CMAKE_BINARY_DIR}/thbook/version.tex
                  DEPENDS legacy-make
                  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)
# generate InnoSetup config file
if (WIN32)
    configure_file(innosetup.ini.in innosetup.ini)
endif()

# set an installation path for ini files
if (IS_ABSOLUTE ${CMAKE_INSTALL_SYSCONFDIR})
  set(TH_PATH_INI "${CMAKE_INSTALL_SYSCONFDIR}")
else()
  set(TH_PATH_INI "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_SYSCONFDIR}")
endif()

if (BUILD_THERION)
    # therion lib
    add_library(therion-common STATIC ${THERION_HEADERS} ${THERION_SOURCES})
    target_include_directories(therion-common BEFORE PUBLIC "${CMAKE_BINARY_DIR}" "${CMAKE_SOURCE_DIR}" "${CMAKE_SOURCE_DIR}/extern")
    target_link_libraries(therion-common PUBLIC PkgConfig::PROJ fmt::fmt shp poly2tri common-utils)
    target_compile_definitions(therion-common PUBLIC PROJ_VER=${PROJ_MVER} "TH${THPLATFORM}" $<$<BOOL:${ENABLE_THDEBUG}>:THDEBUG>)
    add_dependencies(therion-common 
        version
        generate_thsymbolsetlist
        generate_thlang
        generate_tex
        generate_mpost
        generate_thchencdata
        generate_thcsdata
    )

    # therion executable
    add_executable(therion therion-main.cxx)
    target_link_libraries(therion PUBLIC therion-common)

    install(TARGETS therion RUNTIME COMPONENT th-runtime)
    install(FILES therion.ini TYPE SYSCONF RENAME therion.ini.new COMPONENT th-runtime)
    install(CODE
        "if (NOT EXISTS ${TH_PATH_INI}/therion.ini)
            file(INSTALL ${CMAKE_CURRENT_SOURCE_DIR}/therion.ini DESTINATION ${TH_PATH_INI})
        endif()"
        COMPONENT th-runtime)

    # unit tests
    add_executable(utest utest-proj.cxx utest-icase.cxx utest-thdouble.cxx utest-main.cxx)
    target_link_libraries(utest PUBLIC therion-common Catch2::Catch2)
    enable_testing()
    if (NOT WIN32)
        add_test(NAME utest COMMAND $<TARGET_FILE:utest> WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    endif()

    # updates thlibrarydata.cxx
    add_custom_target(library 
        ${CMAKE_COMMAND} -D THERION=$<TARGET_FILE:therion> -P cmake/Library.cmake
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )

    add_subdirectory(extern/poly2tri)
    add_subdirectory(mpost)
    add_subdirectory(thchencdata)
    add_subdirectory(tex)
    add_subdirectory(thlang)
    add_subdirectory(samples)
endif()

add_subdirectory(loch)
add_subdirectory(thbook)
add_subdirectory(xtherion)

# deployment of DLL dependencies on Windows
if (BUILD_THERION AND BUILD_LOCH AND WIN32)
    set(DLLS_DIR ${CMAKE_BINARY_DIR}/dependencies)
    add_custom_target(deploy 
        ${CMAKE_COMMAND} -D THERION=$<TARGET_FILE:therion>
                         -D LOCH=$<TARGET_FILE:loch>
                         -D DLLS_DIR=${DLLS_DIR}
                         -P cmake/Deploy.cmake
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    set_target_properties(deploy PROPERTIES ADDITIONAL_CLEAN_FILES ${DLLS_DIR})
endif()

=== Makefile ===
# common therion objects
CMNOBJECTS = thdate.o extern/shapelib/shpopen.o extern/shapelib/dbfopen.o extern/shapelib/safileio.o  \
  thbuffer.o thmbuffer.o thlogfile.o thtmpdir.o thlocale.o \
  thparse.o thcmdline.o thconfig.o thinput.o thchenc.o thdatabase.o \
  thdataobject.o thdatareader.o thsurvey.o thendsurvey.o thdata.o \
  thperson.o thtf.o thtfangle.o thtflength.o thtfpwf.o \
  thdataleg.o thobjectname.o thinfnan.o thlayout.o thlookup.o thcomment.o \
  thinit.o thdb1d.o thsvxctrl.o thdatastation.o thobjectid.o \
  thobjectsrc.o thgrade.o thlibrary.o thgeomag.o thbezier.o \
  thexport.o thexporter.o thselector.o extern/img.o \
  thexpmodel.o thdb2d00.o thscrapis.o thcs.o thcsdata.o thexptable.o \
  thdb2d.o thscrap.o thendscrap.o th2ddataobject.o thdb2dprj.o \
  thdb2dpt.o thdb2dlp.o thdb2dab.o thdb2dji.o thdb2dmi.o thdb2dcp.o \
  thdb2dxm.o thdb2dxs.o thscraplo.o thscraplp.o thscrapen.o \
  thpoint.o thline.o tharea.o thlegenddata.o thmpost.o thsymbolsets.o \
  thjoin.o thmap.o thexpmap.o thlayoutln.o thlayoutclr.o thexpsys.o thexpuni.o \
  thconvert.o thpdf.o thpdfdbg.o thpdfdata.o thtexfonts.o \
  thsymbolset.o thlang.o thmapstat.o thexpdb.o thpic.o thsketch.o thproj.o \
  extern/lxMath.o extern/lxFile.o thdb3d.o thsurface.o thimport.o thsvg.o thepsparse.o \
  thtrans.o thwarpp.o thwarppt.o thwarppme.o thwarp.o thexpshp.o thattr.o thtex.o \
  extern/poly2tri/common/shapes.o extern/poly2tri/sweep/advancing_front.o extern/poly2tri/sweep/sweep.o extern/poly2tri/sweep/cdt.o extern/poly2tri/sweep/sweep_context.o \
  extern/fmt/src/format.o extern/fmt/src/os.o extern/quickhull/QuickHull.o therion.o
TESTOBJECTS = utest-main.o utest-proj.o utest-icase.o

EXT =

# Prefix to install to (override like so: make PREFIX=/usr)
PREFIX ?= /usr/local
# Directory to install config files in (override like so: make SYSCONFDIR=/etc)
SYSCONFDIR ?= $(PREFIX)/etc

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = c++
##CC = gcc
##POBJECTS =
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHLINUX
##CCPFLAGS = -DTHLINUX
##LDPFLAGS = -s
##export THPLATFORM = LINUX
##export OUTDIR = ../therion.bin
##THXTHMKCMD = $(OUTDIR)/therion


# PLATFORM DEBIAN
CXX ?= c++
CC ?= gcc
POBJECTS =
LOCHEXE = loch/loch
CXXPFLAGS = -DTHLINUX
CCPFLAGS = -DTHLINUX
LDPFLAGS = -s
export THPLATFORM = LINUX
export OUTDIR = .
THXTHMKCMD = $(OUTDIR)/therion


# PLATFORM WIN32
##EXT = .exe
##CXX ?= c++
##CC ?= gcc
##POBJECTS = therion.res
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHWIN32
##CCPFLAGS = -DTHWIN32
##LDPFLAGS = -static-libgcc -s
##export THPLATFORM = WIN32
##export OUTDIR ?= ../therion.bin
##THXTHMKCMD = $(OUTDIR)/therion

# PLATFORM WIN32CROSS
##CROSS ?= i686-w64-mingw32.static-
##EXT = .exe
##CXX = $(CROSS)c++
##export CC = $(CROSS)gcc
##export AR = $(CROSS)ar
##POBJECTS = therion.res
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHWIN32
##CCPFLAGS = -DTHWIN32
##LDPFLAGS = -static-libgcc -static -s
##export THPLATFORM = WIN32
##THXTHMKCMD = therion
##export OUTDIR ?= ../therion.bin

# PLATFORM MACOSX
##CXX = c++
##CC = cc
##LOCHEXE = loch/loch
##POBJECTS =
##CXXPFLAGS = -DTHMACOSX
##CCPFLAGS = -DTHMACOSX
##LDPFLAGS =
##export THPLATFORM = MACOSX
##export OUTDIR = .
##THXTHMKCMD = ./therion

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(LDPFLAGS)

# BUILD OXYGEN
CCBFLAGS = -O2
CXXBFLAGS = -O2
LDBFLAGS = $(LDPFLAGS)

# BUILD RELEASE
##CCBFLAGS =
##CXXBFLAGS =
##LDBFLAGS = $(LDPFLAGS)

# BUILD DEBUG
##CCBFLAGS = -ggdb -fsanitize=address
##CXXBFLAGS = -ggdb -DTHDEBUG -fsanitize=address
##LDBFLAGS =

# BUILD ENDCONFIG

# proj4 settings
PROJ_UNSUPPORTED = 5.0.0 5.0.1 6.0.0 6.1.0 6.1.1 6.2.0
PROJ_VER = $(shell $(CROSS)pkg-config proj --modversion)
ifneq ($(filter $(PROJ_VER),$(PROJ_UNSUPPORTED)),)
    $(error unsupported Proj version: $(PROJ_VER))
endif
PROJ_LIBS ?= $(shell $(CROSS)pkg-config proj --libs --static)
PROJ_MVER ?= $(shell echo $(PROJ_VER) | sed 's/\..*//')
CXXJFLAGS ?= -DPROJ_VER=$(PROJ_MVER) -I$(shell $(CROSS)pkg-config proj --variable=includedir)


# compiler settings
CXXFLAGS = -DIMG_API_VERSION=1 -Wall $(CXXPFLAGS) $(CXXBFLAGS) $(CXXJFLAGS) -Iextern -Iextern/shapelib -Iextern/fmt/include -std=c++14
CCFLAGS = -DIMG_API_VERSION=1 -Wall $(CCPFLAGS) $(CCBFLAGS)
OBJECTS = $(addprefix $(OUTDIR)/,$(POBJECTS)) $(addprefix $(OUTDIR)/,$(CMNOBJECTS))
TESTOBJECTS_P = $(addprefix $(OUTDIR)/,$(TESTOBJECTS))


# linker settings
LIBS = $(PROJ_LIBS)
LDFLAGS = $(LDBFLAGS)


$(OUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.cpp
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<

all: version outdirs $(OUTDIR)/therion tests doc xtherion/xtherion $(LOCHEXE)

outdirs:
	mkdir -p $(OUTDIR)/extern/poly2tri/sweep/
	mkdir -p $(OUTDIR)/extern/poly2tri/common/
	mkdir -p $(OUTDIR)/extern/quickhull
	mkdir -p $(OUTDIR)/extern/shapelib
	mkdir -p $(OUTDIR)/extern/fmt/src
	mkdir -p $(OUTDIR)/loch
	mkdir -p $(OUTDIR)/loch/help
	mkdir -p $(OUTDIR)/loch/help/en
	mkdir -p $(OUTDIR)/loch/help/sk
	mkdir -p $(OUTDIR)/xtherion
	mkdir -p $(OUTDIR)/thbook

version: outdirs
	python3 set_version.py .
ifeq ($(THPLATFORM),WIN32)
	echo "[PROJ]" > $(OUTDIR)/innosetup.ini && echo "version=$(PROJ_MVER)" >> $(OUTDIR)/innosetup.ini
endif

thversion.h: version

$(OUTDIR)/therion: $(OBJECTS)
	$(CXX) $(CXXFLAGS) -o $(OUTDIR)/therion$(EXT) therion-main.cxx $(OBJECTS) $(LDFLAGS) $(LIBS)

$(OUTDIR)/utest$(EXT): $(OBJECTS) $(TESTOBJECTS_P) 
	$(CXX) $(CXXFLAGS) -o $(OUTDIR)/utest$(EXT) $(OBJECTS) $(TESTOBJECTS_P) $(LDFLAGS) $(LIBS)

tests: $(OUTDIR)/utest$(EXT)
ifneq ($(THPLATFORM),WIN32)
	$(OUTDIR)/utest$(EXT)
endif

$(OUTDIR)/therion.res: therion.rc
	$(CROSS)windres -i therion.rc -J rc -o $(OUTDIR)/therion.res -O coff

init:
	./therion --print-init-file > therion.ini

install: all
	tclsh makeinstall.tcl $(THPLATFORM) $(DESTDIR)$(PREFIX) $(DESTDIR)$(SYSCONFDIR)

release:
	python3 make_release.py

depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -MM $(CXXFLAGS) *.cxx >> Makefile
	perl makedepend2.pl

library: thversion.h
	$(THXTHMKCMD) --print-library-src thlibrarydata.thcfg > thlibrarydata.log
	perl makelibrary.pl thlibrarydata.log > thlibrarydata.tmp
	perl maketest.pl thlibrarydata.tmp
	perl makefile.pl mv thlibrarydata.tmp thlibrarydata.cxx

ifeq ($(THXTHMKCMD),$(OUTDIR)/therion)
  THERION_TCL_DEPS += $(OUTDIR)/therion
endif

xtherion/therion.tcl: $(THERION_TCL_DEPS)
	$(THXTHMKCMD) --print-xtherion-src > xtherion/therion.tcl

xtherion/xtherion: version xtherion/therion.tcl xtherion/*.tcl
	$(MAKE) -C ./xtherion

loch/loch: version loch/*.h loch/*.cxx loch/*.c
	$(MAKE) -C ./loch

doc: $(OUTDIR)/thbook/thbook.pdf

thbook: version $(OUTDIR)/thbook/thbook.pdf

samples: $(OUTDIR)/samples.doc/index.tex

samples-quick:
	$(MAKE) -C samples quick
	touch thbook/version.tex
	$(MAKE) -C thbook

samples-html:
	$(MAKE) -C samples html

$(OUTDIR)/samples.doc/index.tex:
	$(MAKE) -C samples
	touch thbook/version.tex
	$(MAKE) -C thbook

$(OUTDIR)/thbook/thbook.pdf: thbook/*.tex thversion.h
	$(MAKE) -C thbook

clean:
	perl makefile.pl rm -q ./xtherion/therion.tcl
	perl makefile.pl rmdir -q samples.doc
	$(MAKE) -C ./samples clean
	$(MAKE) -C ./loch clean
	$(MAKE) cleanrest

cleanrest:
	$(MAKE) -C ./xtherion clean
	$(MAKE) -C ./loch clean
	perl makefile.pl rm -q thmpost.cxx thtex.h thlangdata.h thchencdata.cxx thcsdata.h thmpost.h thcsdata.cxx thtex.cxx thsymbolsetlist.h thsymbolsets.cxx thsymbolsets.h thlangdatafields.h thchencdata.h SYMBOLS.txt
	perl makefile.pl rm -q therion ./xtherion/xtherion ./xtherion/xtherion.tcl therion.exe *~ *.log *.o thchencdata/*~ .xtherion.dat ./xtherion/ver.tcl thversion.h thbook/version.tex
	perl makefile.pl rm -q xtherion/*~ .xth_thconfig_xth xtherion/screendump thlang/*~
	perl makefile.pl rm -q extern/*.o extern/*~ extern/quickhull/*.o extern/shapelib/*.o extern/poly2tri/common/*.o extern/poly2tri/sweep/*.o samples/*~ samples/*.log
	perl makefile.pl rm -q symbols.html therion.res innosetup.ini
	perl makefile.pl rm -q tri/*.o tri/*~
	perl makefile.pl rm -q utest
	perl makefile.pl rm -q tex/*~
	perl makefile.pl rm -q us.stackdump loch/us.stackdump samples/us.stackdump xtherion/us.stackdump
	perl makefile.pl rm -q mpost/*~ examples/*~ examples/therion.log
	perl makefile.pl rm -q core symbols.xhtml cave.kml
	perl makefile.pl rm -q data.3d data.svx data.pos data.pts data.err data.plt
	perl makefile.pl rm -q cave.3d cave.lox cave.thm cave.pdf cave.sql cave.xhtml therion.tcl cave_a.pdf cave_m.pdf cave.vrml cave.wrl cave.3dmf cave.svg cave.tlx
	perl makefile.pl rm -q ./thbook/*~ ./thbook/thbook.log ./thbook/thbook.pdf ./lib/*~ ./mpost/*~ ./tex/*~
	perl makefile.pl rm -q extern/fmt/CMakeCache.txt extern/fmt/Makefile extern/fmt/libfmt.a extern/fmt/cmake_install.cmake extern/fmt/src/*.o
	perl makefile.pl rmdir -q doc thTMPDIR samples.doc symbols cave.shp tests/.doc
	perl makefile.pl rmdir -q doc symbols cave.shp tests/.doc
	perl makefile.pl rmdir -q thTMPDIR samples/*/thTMPDIR samples/*/*/thTMPDIR
	perl makefile.pl rmdir -q extern/fmt/CMakeFiles

thmpost.h: mpost/*.mp
	$(MAKE) -C ./mpost

thmpost.cxx: thmpost.h
thsymbolsets.h: thmpost.h thsymbolsetlist.h
thsymbolsets.cxx: thsymbolsets.h

thsymbolsetlist.h: thsymbolsetlist.pl mpost/thTrans.mp
	perl thsymbolsetlist.pl

thtex.h: tex/*.tex
	$(MAKE) -C ./tex

thtex.cxx: thtex.h

thchencdata.cxx: thchencdata.h
thchencdata.h: thchencdata/*.TXT
	$(MAKE) -C ./thchencdata

thcsdata.h: thcsdata.tcl
	tclsh thcsdata.tcl $(shell $(CROSS)pkg-config proj --variable=prefix)/share/proj

update:
	$(MAKE) -C ./thlang update

unixify: clean
	tclsh makeunixify.tcl

thlangdata.h: thlang/texts.txt
	$(MAKE) -C ./thlang

thlangdatafields.h: thlangdata.h
	$(MAKE) -C ./thlang

config-debug:
	perl makeconfig.pl BUILD DEBUG
	cd loch; perl makeconfig.pl BUILD DEBUG

config-release:
	perl makeconfig.pl BUILD RELEASE
	cd loch; perl makeconfig.pl BUILD RELEASE

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN
	cd loch; perl makeconfig.pl BUILD OXYGEN

config-ozone:
	perl makeconfig.pl BUILD OZONE
	cd loch; perl makeconfig.pl BUILD OZONE

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN
	cd loch; perl makeconfig.pl PLATFORM DEBIAN

config-linux:
	perl makeconfig.pl PLATFORM LINUX
	cd loch; perl makeconfig.pl PLATFORM LINUX

config-win32:
	perl makeconfig.pl PLATFORM WIN32
	cd loch; perl makeconfig.pl PLATFORM WIN32

config-win32cross:
	perl makeconfig.pl PLATFORM WIN32CROSS
	cd loch; perl makeconfig.pl PLATFORM WIN32CROSS

config-macosx:
	perl makeconfig.pl PLATFORM MACOSX
	cd loch; perl makeconfig.pl PLATFORM MACOSX

# external sources
$(OUTDIR)/extern/lxMath.o: loch/lxMath.h loch/lxMath.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxMath.o loch/lxMath.cxx

$(OUTDIR)/extern/lxFile.o: loch/lxFile.h loch/lxFile.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxFile.o loch/lxFile.cxx

extern/img.o: extern/img.c extern/img.h
extern/poly2tri/common/shapes.o: extern/poly2tri/common/shapes.cc extern/poly2tri/common/shapes.h
extern/poly2tri/sweep/advancing_front.o: extern/poly2tri/sweep/advancing_front.cc
extern/poly2tri/sweep/sweep.o: extern/poly2tri/sweep/sweep.cc
extern/poly2tri/sweep/cdt.o: extern/poly2tri/sweep/cdt.cc
extern/poly2tri/sweep/sweep_context.o: extern/poly2tri/sweep/sweep_context.cc
extern/fmt/src/format.o: extern/fmt/src/format.cc extern/fmt/include/fmt/format-inl.h extern/fmt/include/fmt/format.h extern/fmt/include/fmt/core.h
extern/fmt/src/os.o: extern/fmt/src/os.cc extern/fmt/include/fmt/os.h extern/fmt/include/fmt/format.h extern/fmt/include/fmt/core.h


# DEPENDENCIES
$(OUTDIR)/th2ddataobject.o: th2ddataobject.cxx th2ddataobject.h thdataobject.h \
 thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
 thdataleg.h thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \

=== loch/Makefile ===
OUTDIR ?= .
THPLATFORM ?= LINUX
ifneq ($(OUTDIR),.)
LOUTDIR = ../$(OUTDIR)/loch
else
LOUTDIR = .
endif



# common therion objects
CMNOBJECTS = \
  lxTR.o lxOGLFT.o lxSetup.o lxRender.o lxWX.o \
  lxImgIO.o lxLRUD.o lxFile.o lxSTree.o \
  lxData.o lxMath.o lxSView.o lxSScene.o \
  lxGUI.o lxGLC.o lxOptDlg.o lxAboutDlg.o lxPres.o lxSStats.o \
  img.o

EXT =

# notdir required in msys/mingw as it doesn't interpret leading slash correctly
WX_CONFIG ?= $(notdir $(shell which \
  wx-config-gtk3 \
  wx-config-3.1 \
  wx-config \
  i686-w64-mingw32.static-wx-config \
  x86_64-w64-mingw32.static-wx-config \
  2> /dev/null | head -n1))
ifeq ($(WX_CONFIG),)
$(error wx-config not found)
endif

VTKSUFFIX = $(shell tclsh ./getvtkver.tcl suffix)
VTKVERSION = $(shell tclsh ./getvtkver.tcl version)
VTKPATH = $(shell tclsh ./getvtkver.tcl incpath)
VTKLIBPATH = $(shell tclsh ./getvtkver.tcl libpath)
VTKV6 = $(shell tclsh ./getvtkver.tcl version6)
VTKV9 = $(shell tclsh ./getvtkver.tcl version9)
VTKLIBS = $(shell tclsh ./getvtkver.tcl libs)
VTKLIBSUFFIX=$(shell tclsh ./getvtkver.tcl libsuffix)
ifeq ($(VTKV6),1)
VTKLIBS = \
    -lvtkCommonExecutionModel$(VTKLIBSUFFIX) \
    -lvtkCommonDataModel$(VTKLIBSUFFIX) \
    -lvtkCommonCore$(VTKLIBSUFFIX) \
    -lvtkIOPLY$(VTKLIBSUFFIX) \
    -lvtkFiltersCore$(VTKLIBSUFFIX) \
    -lvtkFiltersHybrid$(VTKLIBSUFFIX) \
    -lvtkIOLegacy$(VTKLIBSUFFIX) \
    $(shell pkg-config --libs freetype2)
else
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtkjpeg -lvtkpng -lvtkzlib -lvtksys -lfreetype
endif
VTKLIBS+= -lpng -ljpeg



# VTKVERSION = 5.4
# VTKPATH = /usr/local/include/vtk-$(VTKVERSION)
# VTKLIBPATH = /usr/local/lib/vtk-$(VTKVERSION)
POSTMAKE =
STRIPFLAG = -s

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = c++
##CC = gcc
##POBJECTS = lxR2P.o
##ifeq ($(VTKV6),1)
##VTKLIBS = -lvtkCommonExecutionModel -lvtkCommonDataModel -lvtkCommonCore -lvtkIOPLY -lvtkFiltersCore -lvtkFiltersHybrid -lvtkIOLegacy -lfreetype -lpng -ljpeg
##else
##VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
##endif
##CXXPFLAGS = -DLXLINUX -std=c++14 $(shell wx-config --cxxflags) -Wno-deprecated $(shell pkg-config freetype2 --cflags) -I$(VTKPATH)
##CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
##LXLIBDIR = linux
##PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz
##LXPLATFORM = LINUX

# PLATFORM DEBIAN
CXX ?= c++
CC ?= gcc
ifeq ($(VTKV6),1)
else
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
endif
CXXPFLAGS = \
    -std=c++14 \
    -Wno-deprecated \
    $(shell $(WX_CONFIG) --cxxflags) \
    $(shell pkg-config freetype2 --cflags) \
    -I$(VTKPATH)
CCPFLAGS = $(shell $(WX_CONFIG) --cflags)
LXLIBDIR = linux
PLIBS = $(shell $(WX_CONFIG) --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz
LXPLATFORM = LINUX

# LXLINUX doesn't work with Arch Linux
ifneq ($(shell lsb_release -si),Arch)
  POBJECTS = lxR2P.o
  CXXPFLAGS += -DLXLINUX
  CCPFLAGS += -DLXLINUX
endif

# PLATFORM WIN32
##CXX = c++
##CC = gcc
##POBJECTS = loch.res lxR2D.o
##CXXPFLAGS = -W -Wall -DLXWIN32 $(shell $(WX_CONFIG) --static --cxxflags) $(shell pkg-config freetype2 --cflags) -I$(VTKPATH) -Wno-deprecated
##CCPFLAGS = -W -Wall -DLXWIN32 $(shell $(WX_CONFIG) --static --cflags)
##LXLIBDIR = mingw
##PLIBS = $(shell pkg-config freetype2 --libs) -lharfbuzz -lbrotlidec -lbrotlicommon -lgraphite2 -lusp10 -lbz2 -lz $(shell $(WX_CONFIG) --static --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LXPLATFORM = WIN32
##STRIPFLAG = -static-libgcc -s

# PLATFORM WIN32CROSS
##CROSS ?= i686-w64-mingw32.static-
##CROSS2 = $(shell echo $(CROSS) | sed 's/-$$//')
##EXT = .exe
##WX_CONFIG = wx-config
##VTKVERSION = 8.2
##VTKPATH = /usr/lib/mxe/usr/$(CROSS2)/include/vtk-$(VTKVERSION)
##VTKLIBPATH = /usr/lib/mxe/usr/$(CROSS2)/lib
##VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkIOPLY-$(VTKVERSION)\
##  -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) \
##  -lvtkIOLegacy-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkIOCore-$(VTKVERSION) \
##  -lvtkCommonTransforms-$(VTKVERSION) -lvtkCommonMisc-$(VTKVERSION) -lvtkCommonMath-$(VTKVERSION) -lvtkCommonSystem-$(VTKVERSION) \
##  -lvtksys-$(VTKVERSION) -lvtkfreetype-$(VTKVERSION) -lvtkpng-$(VTKVERSION) -lvtkjpeg-$(VTKVERSION) -lvtkzlib-$(VTKVERSION)
##CXX = $(CROSS)c++
##CC = $(CROSS)gcc
##POBJECTS = loch.res lxR2D.o
##CXXPFLAGS = -W -Wall -std=c++14 -DLXWIN32 $(shell $(CROSS)wx-config --static --cxxflags) $(shell $(CROSS)pkg-config freetype2 --cflags) -I$(VTKPATH) -Wno-deprecated
##CCPFLAGS = -W -Wall -DLXWIN32 $(shell $(CROSS)wx-config --static --cflags)
##LXLIBDIR =
##PLIBS = $(shell $(CROSS)pkg-config freetype2 --libs) $(shell $(CROSS)wx-config --static --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LXPLATFORM = WIN32
##STRIPFLAG = -static-libgcc -static -s

# PLATFORM MACOSX
##CXX = c++
##CC = cc
##POBJECTS =
##CXXPFLAGS = -W -Wall -std=c++14 -DLXMACOSX $(shell wx-config --cxxflags) $(shell pkg-config freetype2 --cflags) -I$(VTKPATH) -Wno-deprecated -I/usr/X11R6/include -I/usr/X11R6/include/freetype2
##CCPFLAGS = -W -Wall -DLXMACOSX $(shell wx-config --cflags) -I/usr/X11R6/include
##LXLIBDIR =
##PLIBS = -lz -L/usr/X11R6/lib $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LOCHAPPBINDIR := $(shell mkdir -p ./loch.app/Contents/MacOS)
##POSTMAKE = cp -f ./loch ./loch.app/Contents/MacOS/loch
##STRIPFLAG =

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(STRIPFLAG)

# BUILD OXYGEN
CCBFLAGS = -O2 -DNDEBUG
CXXBFLAGS = -O2 -DNDEBUG
LDBFLAGS = $(STRIPFLAG)

# BUILD RELEASE
##CCBFLAGS = -DNDEBUG
##CXXBFLAGS = -DNDEBUG
##LDBFLAGS = $(STRIPFLAG)

# BUILD DEBUG
##CCBFLAGS = -ggdb
##CXXBFLAGS = -ggdb -DLXDEBUG
##LDBFLAGS =

# BUILD ENDCONFIG


# compiler settings
CXXFLAGS := -Wall -D_GNU_SOURCE -DLOCH $(CXXPFLAGS) $(CXXBFLAGS) -DIMG_API_VERSION=1
CCFLAGS := -Wall -D_GNU_SOURCE -DLOCH $(CCPFLAGS) $(CCBFLAGS) -DIMG_API_VERSION=1
OBJECTS = $(addprefix $(LOUTDIR)/,$(POBJECTS)) $(addprefix $(LOUTDIR)/,$(CMNOBJECTS))


# linker settings
LIBS = $(PLIBS)
LDFLAGS = $(LDBFLAGS)


$(LOUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<


all: $(LOUTDIR)/loch
	$(MAKE) -C ./help

hlp:
	$(MAKE) -C ./help

$(LOUTDIR)/loch: $(OBJECTS)
	$(CXX) -o $(LOUTDIR)/loch$(EXT) -Wall $(OBJECTS) $(LIBS) $(LDFLAGS)
	$(POSTMAKE)

$(LOUTDIR)/loch.res: loch.rc loch.ico
	$(CROSS)windres -i loch.rc $(shell $(CROSS)$(WX_CONFIG) --cflags | tr ' ' '\n' | grep "^-I" | tr '\n' ' ') -J rc -o $(LOUTDIR)/loch.res -O coff

graphs:
	dot -Tps graph-vispipe.dot -o graph-vispipe.ps


depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -DLXDEPCHECK -DLOCH -D'wxCHECK_VERSION(X,Y,Z)=1' -MM *.cxx >> Makefile
	$(CC) -DLXDEPCHECK -DLOCH -MM *.c >> Makefile
	perl makedepend2.pl


config-debug:
	perl makeconfig.pl BUILD DEBUG

test-release:
	zip -9 loch.zip loch.exe test.th test.jpg thconfig

config-release:
	perl makeconfig.pl BUILD RELEASE

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN

config-ozone:
	perl makeconfig.pl BUILD OZONE

config-linux:
	perl makeconfig.pl PLATFORM LINUX

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN

config-win32:
	perl makeconfig.pl PLATFORM WIN32

config-win32cross:
	perl makeconfig.pl PLATFORM WIN32CROSS

config-macosx:
	perl makeconfig.pl PLATFORM MACOSX

clean:
	perl makefile.pl rm -q *~
	perl makefile.pl rm -q help/*/*~
	perl makefile.pl rm -q loch.exe
	perl makefile.pl rm -q loch.res
	perl makefile.pl rm -q loch
	perl makefile.pl rm -q loch.app/Contents/MacOS/loch
	perl makefile.pl rm -q *.o
	perl makefile.pl rm -q *.log
	perl makefile.pl rm -q core
	perl makefile.pl rmdir -q .xvpics
	perl makefile.pl rm -q *.bmp
	perl makefile.pl rm -q *.ppm
	perl makefile.pl rm -q *.zip
	perl makefile.pl rm -q *.pdf
	perl makefile.pl rm -q *.png
	$(MAKE) -C help clean



# DEPENDENCIES
$(LOUTDIR)/lxAboutDlg.o: lxAboutDlg.cxx lxWX.h icons/about.xpm ../thversion.h
$(LOUTDIR)/lxData.o: lxData.cxx lxData.h lxMath.h lxImgIO.h lxFile.h lxLRUD.h
$(LOUTDIR)/lxFile.o: lxFile.cxx lxFile.h lxMath.h img.h ../extern/img.h
$(LOUTDIR)/lxGLC.o: lxGLC.cxx lxGLC.h lxMath.h lxGUI.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxSView.h lxWX.h lxFNT6x13_bdf.h lxFNT10x20_bdf.h \
 lxFNTFreeSans_ttf.h lxRender.h lxTR.h
$(LOUTDIR)/lxGUI.o: lxGUI.cxx lxGUI.h lxGLC.h lxMath.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxRender.h lxOptDlg.h lxAboutDlg.h lxSView.h lxWX.h lxSScene.h \
 lxSTree.h lxPres.h icons/open.xpm icons/render.xpm icons/reload.xpm \
 icons/stereo.xpm icons/rotation.xpm icons/lockrot.xpm icons/fit.xpm \
 icons/home.xpm icons/rendersetup.xpm icons/plan.xpm icons/profile.xpm \
 icons/fullscreen.xpm icons/orto.xpm icons/camera.xpm icons/scene.xpm \
 icons/viscline.xpm icons/vissurface.xpm icons/visbbox.xpm \
 icons/viswalls.xpm icons/visinds.xpm icons/visentrance.xpm \
 icons/visfix.xpm icons/visstation.xpm icons/vislabel.xpm loch.xpm
$(LOUTDIR)/lxImgIO.o: lxImgIO.cxx lxImgIO.h
$(LOUTDIR)/lxLRUD.o: lxLRUD.cxx lxLRUD.h lxMath.h
$(LOUTDIR)/lxMath.o: lxMath.cxx lxMath.h
$(LOUTDIR)/lxOGLFT.o: lxOGLFT.cxx lxOGLFT.h
$(LOUTDIR)/lxOptDlg.o: lxOptDlg.cxx lxWX.h lxGUI.h lxGLC.h lxMath.h
$(LOUTDIR)/lxPres.o: lxPres.cxx lxPres.h lxWX.h lxGUI.h lxGLC.h lxMath.h lxSetup.h \
 lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxRender.o: lxRender.cxx lxRender.h lxWX.h lxGLC.h lxMath.h lxGUI.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h lxTR.h
$(LOUTDIR)/lxSScene.o: lxSScene.cxx lxSScene.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSTree.o: lxSTree.cxx lxSTree.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSView.o: lxSView.cxx lxSView.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSetup.o: lxSetup.cxx lxSetup.h lxData.h lxMath.h lxImgIO.h lxFile.h
$(LOUTDIR)/lxWX.o: lxWX.cxx lxWX.h
$(LOUTDIR)/img.o: img.c ../extern/img.c ../extern/img.h
$(LOUTDIR)/lxR2D.o: lxR2D.c lxR2D.h
$(LOUTDIR)/lxR2P.o: lxR2P.c lxR2P.h
$(LOUTDIR)/lxTR.o: lxTR.c lxTR.h

=== mpost/CMakeLists.txt ===
set(MPOST_SOURCES
    thArea.mp
    therion.mp
    thLine.mp
    thPoint.mp
    thSpecial.mp
    thText.mp
    thTrans.mp
    uAUT.mp
    uSBE.mp
    genmpost.pl)
    
set(GENERATED_SOURCES 
    ${CMAKE_BINARY_DIR}/thmpost.h 
    ${CMAKE_BINARY_DIR}/thmpost.cxx
    ${CMAKE_BINARY_DIR}/thsymbolsets.h
    ${CMAKE_BINARY_DIR}/thsymbolsets.cxx)

therion_copy_files(${MPOST_SOURCES})
therion_make_files_lists(MPOST ${MPOST_SOURCES})

add_custom_command(OUTPUT ${GENERATED_SOURCES}
                   COMMAND perl genmpost.pl
                   DEPENDS ${MPOST_BIN}
                   WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_custom_target(generate_mpost DEPENDS ${GENERATED_SOURCES})

=== samples/CMakeLists.txt ===
# get the relative path to generated samples to ensure reproducible builds,
# as the path is written to index.tex and also in the metadata (PTEX.FileName)
# of PDF images included into thbook.pdf
file(RELATIVE_PATH SAMPLES_REL_DIR ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR})
string(REGEX REPLACE "/$" "" SAMPLES_REL_DIR ${SAMPLES_REL_DIR})

# Build samples and add them to the thbook.
therion_copy_files(samples.tcl)
add_custom_target(
  samples
  COMMAND tclsh samples.tcl ${SAMPLES_REL_DIR} --generate-tex-only
  COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_BINARY_DIR}/thbook/version.tex
  COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target thbook
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/samples.tcl
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
add_dependencies(samples samples-build)

# build samples in html format, including the conversion of PDF to PNG images
add_custom_target(
  samples-html
  COMMAND tclsh samples.tcl ${SAMPLES_REL_DIR} --generate-html-images
  USES_TERMINAL
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/samples.tcl
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
add_dependencies(samples-html therion)

 # subdirectories will add dependencies to these targets
add_custom_target(samples-build)
add_custom_target(samples-verify-crc)
add_custom_target(samples-generate-crc)

# Function for registration of therion samples to the build.
# Usage:
# therion_add_sample(<unique_name> <thconfig_file>
#                    DEPENDS_SRC <source_files_dependencies>
#                    DEPENDS_OTHER <other_dependencies>)
# DEPENDS_SRC - relative names of source files needed to build the sample
# DEPENDS_OTHER - absolute paths of dependency files or targets
function(therion_add_sample SAMPLE_NAME THCONFIG)
    # CMake will parse these optional arguments
    set(MULTI_ARGS OUTPUT DEPENDS_SRC DEPENDS_OTHER)
    cmake_parse_arguments(SAMPLE "" "" "${MULTI_ARGS}" ${ARGN})

    therion_copy_files(${THCONFIG} ${SAMPLE_DEPENDS_SRC}) # copy dependency files to the build dir
    therion_make_files_lists(OUTPUTS ${SAMPLE_OUTPUT}) # make helper lists of files in src and build dirs

    # Build samples with therion.
    add_custom_target(_samples-${SAMPLE_NAME}
                      COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:therion> --reproducible-output ${THCONFIG}
                      DEPENDS ${SAMPLE_DEPENDS_OTHER}
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                      COMMAND_EXPAND_LISTS)
    add_dependencies(_samples-${SAMPLE_NAME} therion)

    # CRC verification: Copy .crc files from source dir and then build the sample with verification.
    add_custom_target(_samples-verify-crc-${SAMPLE_NAME}
                      ${CMAKE_COMMAND} -E copy "$<JOIN:${OUTPUTS_SRC},.crc;>.crc" ${CMAKE_CURRENT_BINARY_DIR}
                      COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:therion> --reproducible-output --verify-output-crc ${THCONFIG}
                      DEPENDS ${SAMPLE_DEPENDS_OTHER}
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                      COMMAND_EXPAND_LISTS)
    add_dependencies(_samples-verify-crc-${SAMPLE_NAME} therion)

    # CRC generation: Build sample with checksum generation and copy resulting .crc files to the source dir.
    add_custom_target(_samples-generate-crc-${SAMPLE_NAME}
                      ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:therion> --reproducible-output --generate-output-crc ${THCONFIG}
                      COMMAND ${CMAKE_COMMAND} -E copy "$<JOIN:${OUTPUTS_BIN},.crc;>.crc" ${CMAKE_CURRENT_SOURCE_DIR}
                      DEPENDS ${SAMPLE_DEPENDS_OTHER}
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                      COMMAND_EXPAND_LISTS)
    add_dependencies(_samples-generate-crc-${SAMPLE_NAME} therion)

    # Make targets with all the samples together.
    add_dependencies(samples-build _samples-${SAMPLE_NAME})
    add_dependencies(samples-verify-crc _samples-verify-crc-${SAMPLE_NAME})
    add_dependencies(samples-generate-crc _samples-generate-crc-${SAMPLE_NAME})
endfunction()

add_subdirectory(areas)
add_subdirectory(basics)
add_subdirectory(cave-list)
add_subdirectory(map-offset)
add_subdirectory(morphing/sample1)
add_subdirectory(morphing/sample2)
add_subdirectory(pocket-topo)
add_subdirectory(q-marks)
add_subdirectory(u-symbols)
add_subdirectory(survex)
add_subdirectory(xelevation)

=== extern/fmt/CMakeLists.txt ===
set(FMT_HEADERS 
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/args.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/color.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/compile.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/core.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/format.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/format-inl.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/chrono.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/locale.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/os.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/ostream.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/printf.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/ranges.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/fmt/xchar.h)

set(FMT_SOURCES 
    ${CMAKE_CURRENT_SOURCE_DIR}/src/format.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/src/os.cc)

add_library(fmt ${FMT_HEADERS} ${FMT_SOURCES})
add_library(fmt::fmt ALIAS fmt)
target_include_directories(fmt SYSTEM PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
set_target_properties(fmt PROPERTIES CXX_CLANG_TIDY "")

=== extern/poly2tri/CMakeLists.txt ===
add_library(poly2tri 
    ${CMAKE_CURRENT_SOURCE_DIR}/common/shapes.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/common/shapes.h
    ${CMAKE_CURRENT_SOURCE_DIR}/common/utils.h
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/advancing_front.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/advancing_front.h
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/cdt.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/cdt.h
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/sweep_context.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/sweep_context.h
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/sweep.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/sweep/sweep.h)

target_include_directories(poly2tri SYSTEM PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
set_target_properties(poly2tri PROPERTIES CXX_CLANG_TIDY "")

=== extern/shapelib/CMakeLists.txt ===
add_library(shp dbfopen.c safileio.c sbnsearch.c shpopen.c shptree.c shapefil.h)
target_include_directories(shp PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

if(UNIX)
    find_library(M_LIB m)
    if(M_LIB)
      target_link_libraries(shp ${M_LIB})
    endif()
endif()

=== samples/xelevation/CMakeLists.txt ===
therion_add_sample(xelevation-1 thconfig.1
                   DEPENDS_SRC thconfig.layout cave1.th cave1.th2
                   OUTPUT map1p.pdf map1x.pdf)

therion_add_sample(xelevation-2 thconfig.2
                   DEPENDS_SRC thconfig.layout cave2.th
                   OUTPUT map2.pdf)

therion_add_sample(xelevation-3 thconfig.3
                   DEPENDS_SRC thconfig.layout cave3.th
                   OUTPUT map3.pdf)

therion_add_sample(xelevation-4 thconfig.4
                   DEPENDS_SRC thconfig.layout cave3.th cave3.th2
                   OUTPUT map4.pdf)

therion_add_sample(xelevation-5 thconfig.5
                   DEPENDS_SRC thconfig.layout cave3.th cave3.th2
                   OUTPUT map5.pdf)

therion_add_sample(xelevation-6 thconfig.6
                   DEPENDS_SRC thconfig.layout cave3.th
                   OUTPUT map6.pdf)

therion_add_sample(xelevation-7 thconfig.7
                   DEPENDS_SRC thconfig.layout cave3.th
                   OUTPUT map7.pdf)

=== samples/morphing/sample1/CMakeLists.txt ===
foreach(I RANGE 1 2)
    therion_add_sample(morphing-1-${I} thconfig.${I}
                       DEPENDS_SRC cave1.jpg cave1.th cave${I}.th2 ../thconfig.layout
                       OUTPUT cave${I}.pdf)
endforeach()

=== samples/survex/ignore/CMakeLists.txt ===
therion_add_sample(survex-ignore thconfig
                   DEPENDS_SRC ignore.th ignore.th2 ../thconfig.layout ignore.3d
                   OUTPUT ignore.pdf)

=== debian/changelog ===
therion (6.0.5-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Budaj <m.budaj@gmail.com>  Sun, 20 Feb 2022 14:35:37 +0100

=== debian/control ===
Source: therion
Section: science
Priority: optional
Maintainer: Martin Budaj <m.budaj@gmail.com>
Uploaders: Wookey <wookey@debian.org>, Olly Betts <olly@survex.com>
Build-Depends: dpkg (>=1.16.2), debhelper, debhelper-compat (=13), perl (>= 5.5), tcl,
  libvtk9-dev, libwxgtk3.0-gtk3-dev, libfreetype6-dev, libjpeg-dev, libpng-dev,
  pkg-config, texlive-base, libproj-dev, libsqlite3-tcl, python3,
  libshp-dev, catch2, cmake, ninja-build, libfmt-dev
Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript
Standards-Version: 4.6.0
Homepage: https://therion.speleo.sk/
Rules-Requires-Root: no

Package: therion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tcl, tk, texlive-base, texlive-metapost, bwidget
Recommends: evince | pdf-viewer, libtk-img, therion-viewer, survex
Suggests: survex-aven, texlive-lang-czechslovak, texlive-lang-cyrillic
Description: Cave surveying - 2D and 3D drawing software
 Therion aids the process of drawing up cave surveys (maps). Drawings are
 done over scans and can be distorted to fit the centreline data. Output is
 in single sheet or atlas style PDF or SVG files. All data is stored in text
 files and a map editor (xtherion) is provided to aid in the creation of the
 files. A wide range of co-ordinate systems is supported.
 .
 Therion can also produce 3D models, generated from walls and
 passage-heights.  Output formats supported are Survex .3d files, VRML, DXF,
 SVG, shapefiles, and the native .lox. Scanned map overlays and relief data
 can be incorporated into models. Therion is compatible with Survex, and
 centreline data can be stored in Survex or Therion form. If survex is
 installed it is used for loop closures. Centreline data and sketches can be
 imported from PocketTopo, allowing full paperless surveying.
 .
 TeX and metapost are used to generate the images. libtk-img is needed to use
 scans in formats other than GIF and PNM (such as PNG and JPEG).
 Survex will be used for loop-closure if installed, but is not required.
 .
 You will need appropriate TeX language packages to process therion files which
 specify those character sets: texlive-lang-czechslovak is needed to process
 the examples, and texlive-lang-cyrillic is also suggested. See README.Debian
 for details.

Package: therion-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, therion
Description: Cave surveying - 3D viewer for therion models
 Therion is cave-survey drawing and modelling software. This package contains
 the 3D model viewer for therion models produced by version 0.4 or later.
 It can also display Survex .3d and Compass .plt files.

Package: therion-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: therion
Depends: ${misc:Depends}
Replaces: therion (<< 0.5.0)
Description: Documentation for Therion Cave surveying software
 Therion is cave-survey drawing and modelling software. This package
 includes the thbook which is the specification for the therion data
 description language. This is not the easiest way to get started;
 there is much more documentation in the Therion wiki:
 https://therion.speleo.sk/wiki/doku.php with introductory guides, FAQs
 and examples. Read those first to get an understanding of how it is
 used.

## therion 6.0.6

=== debian/changelog ===
therion (6.0.6-1build1) kinetic; urgency=medium

  * No-change rebuild against libproj25

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 16 May 2022 16:26:04 +0000

therion (6.0.6-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Budaj <m.budaj@gmail.com>  Tue, 15 Mar 2022 18:32:47 +0100

therion (6.0.5-2) unstable; urgency=medium

  * d/watch: Check for new releases directly on GitHub;
             support for gpg signature checks added;
             format version updated to 4.
  * d/upstream: Public keys added.

 -- Martin Budaj <m.budaj@gmail.com>  Tue, 01 Mar 2022 21:07:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: therion
 Section: science
 Priority: optional
-Maintainer: Martin Budaj <m.budaj@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Martin Budaj <m.budaj@gmail.com>
 Uploaders: Wookey <wookey@debian.org>, Olly Betts <olly@survex.com>
 Build-Depends: dpkg (>=1.16.2), debhelper, debhelper-compat (=13), perl (>= 5.5), tcl,
   libvtk9-dev, libwxgtk3.0-gtk3-dev, libfreetype6-dev, libjpeg-dev, libpng-dev,

## therion 6.1.0

=== debian/changelog ===
therion (6.1.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control: declare conformance with policy 4.6.1.

 -- Martin Budaj <m.budaj@gmail.com>  Fri, 27 May 2022 18:42:47 +0200

## therion 6.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -155,7 +155,18 @@
 
     # therion executable
     add_executable(therion therion-main.cxx)
-    target_link_libraries(therion PUBLIC therion-common)
+    target_link_libraries(therion therion-common)
+
+    # therion resource file
+    if (WIN32)
+        add_custom_command(COMMAND ${CMAKE_RC_COMPILER} -i ${CMAKE_CURRENT_SOURCE_DIR}/therion.rc -J rc -o ${CMAKE_CURRENT_BINARY_DIR}/therion.res -O coff
+                            OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/therion.res
+                            DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/therion.rc ${CMAKE_CURRENT_SOURCE_DIR}/therion.ico
+                            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
+        add_custom_target(generate_resource_therion DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/therion.res)
+        add_dependencies(therion generate_resource_therion)
+        target_link_libraries(therion ${CMAKE_CURRENT_BINARY_DIR}/therion.res)
+    endif()
 
     install(TARGETS therion RUNTIME COMPONENT th-runtime)
     install(FILES therion.ini TYPE SYSCONF RENAME therion.ini.new COMPONENT th-runtime)

=== loch/CMakeLists.txt ===
if (NOT BUILD_THERION AND NOT BUILD_LOCH)
    return()
endif()

set(LOCH_DEFINITIONS _GNU_SOURCE LOCH "LX${THPLATFORM}" GL_SILENCE_DEPRECATION TBB_SUPPRESS_DEPRECATED_MESSAGES=1)

# library common with therion
add_library(common-utils STATIC icase.h lxFile.h lxFile.cxx lxMath.h lxMath.cxx img.h img.c)
target_compile_definitions(common-utils PUBLIC IMG_API_VERSION=1 PRIVATE ${LOCH_DEFINITIONS})

if (NOT BUILD_LOCH)
    return()
endif()

# loch resource file
if (WIN32)
    add_custom_command(COMMAND ${CMAKE_RC_COMPILER} -i ${CMAKE_CURRENT_SOURCE_DIR}/loch.rc "-I$<JOIN:${wxWidgets_INCLUDE_DIRS},;-I>" -J rc -o ${CMAKE_CURRENT_BINARY_DIR}/loch.res -O coff
                        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/loch.res
                        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/loch.rc ${CMAKE_CURRENT_SOURCE_DIR}/loch.ico
                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                        COMMAND_EXPAND_LISTS)
    add_custom_target(generate_resource DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/loch.res)
endif()

include(${CMAKE_SOURCE_DIR}/cmake/LochSources.cmake)
# loch executable
add_executable(loch WIN32 ${LOCH_HEADERS} ${LOCH_SOURCES} $<$<BOOL:${WIN32}>:lxR2D.c> $<$<STREQUAL:${THPLATFORM},LINUX>:lxR2P.c>)
# we need to filter out include directories from wxWidgets cxx flags list, because we have to set them only as system headers to ignore warnings
set(CXX_FLAGS_WITHOUT_INCLUDE_DIRS ${wxWidgets_CXX_FLAGS_LIST})
list(FILTER CXX_FLAGS_WITHOUT_INCLUDE_DIRS EXCLUDE REGEX "-I/")
target_compile_options(loch PRIVATE ${CXX_FLAGS_WITHOUT_INCLUDE_DIRS})
target_compile_definitions(loch PRIVATE ${LOCH_DEFINITIONS})
target_include_directories(loch PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_include_directories(loch SYSTEM PRIVATE ${FREETYPE_INCLUDE_DIRS} ${wxWidgets_INCLUDE_DIRS} ${VTK_INCLUDE_DIRS} ${X11_INCLUDE_DIR})
target_link_libraries(loch PRIVATE
    common-utils
    ${wxWidgets_LIBRARIES}
    ${VTK_LIBRARIES} 
    ${FREETYPE_LIBRARIES}
    OpenGL::GL
    OpenGL::GLU
    ${X11_LIBRARIES}
    $<$<BOOL:${WIN32}>:${CMAKE_CURRENT_BINARY_DIR}/loch.res>
)
add_dependencies(loch version)
if (WIN32)
    add_dependencies(loch generate_resource)
endif()

if (APPLE)
    set(ICONS "loch.app/Contents/Resources/loch.icns")
    target_sources(loch PRIVATE ${ICONS})
    set_target_properties(loch PROPERTIES
        MACOSX_BUNDLE TRUE
        MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/loch.app/Contents/Info.plist"
    )
    set_source_files_properties(${ICONS} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
endif()

install(TARGETS loch 
    RUNTIME 
        COMPONENT loch-runtime
    BUNDLE
        DESTINATION "/Applications"
        COMPONENT loch-runtime
)

add_subdirectory(help)
add_subdirectory(locale)

=== debian/changelog ===
therion (6.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Budaj <m.budaj@gmail.com>  Thu, 23 Jun 2022 18:04:52 +0200
